##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (sampledir)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config/include file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for Registry-KSM

%define name	ksm-registry
%define version	1.0.0
%define release	2.2.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}
%define _dbdir		/var/local/%{name}

Summary:	The KSM-Registry
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		System/Base
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	ksm-lib-sh >= 4.0.0-0.0.0
#Provides:	sampled
#Conflicts:	sampled-other,libsample == 0.0.0
#Obsoletes:	mysampled

%description
This package contains the KSM-Registry. It is used to register TGZ-packages.

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
#%{_confdir}/sample.conf

#%attr(744,root,root)/%{_rcdir}/sampled

%attr(755,root,root)%{_bindir}/ksm-registry

%{_datadir}/RELEASE
%{_datadir}/VERSION

#/usr/share/applications/sample.desktop
#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

#% docdir %{_man1dir}
#% {_man1dir}/sample.1.gz

%docdir %{_man8dir}
%{_man8dir}/ksm-registry.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#% {_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# create group and user
#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/sampleconf.conf && cp %{_confdir}/sampleconf.conf %{_confdir}/sampleconf.conf.rpmsave
#test -e %{_scnfdir}/sampleconf && cp %{_scnfdir}/sampleconf %{_scnfdir}/sampleconf.rpmsave

# disable sample daemon and stop sampledm
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall samplename
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/sampledm.service ]; then
#		systemctl stop sampledm.service
#		systemctl disable sampledm.service
#		rm %{_sysddir}/sampledm.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	if [ -e %{_rcdir}/sampledm ]; then
#		test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1
#		insserv -r sampledm > /dev/null 2>&1
#		rm -f %{_rcdir}/sampledm
#		rm -f %{_sbindir}/rcsampledm
#	fi
#fi

#if [ "$1" == 1 ]; then					# install package
#	# create group and user
#	ngroup=nobody					# new group account
#	ngid=65533					# new GID
#	nuser=nobody					# new user account
#	nuid=65534					# new UID
#	npwd=nobody					# password for new usr
#	ncomm="nobody"					# comment for new usr
#	nhomedir=/var/lib/$nuser			# home dir for new usr
#	nlogsh=/bin/bash			# login shell for new user
#	grep -m 1 "^$ngroup:" /etc/group > /dev/null 2>&1
#	ret=$?
#	if [ "$ret" -eq 1 ]; then			# group not found
#		groupadd --preferred-gid $ngid $ngroup
#	fi
#	grep -m 1 "^$nuser:" /etc/passwd > /dev/null 2>&1
#	ret=$?
#	if [ "$ret" -eq 1 ]; then			# user not found
#		useradd -c "$ncomm" -d $nhomedir -g $ngroup -m -p $npwd --preferred-uid $nuid -s $nlogsh $nuser
#	fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# Definition of vars
# set config pathname. config file needs a version at first cnfvar!
#cf=%{_confdir}/sampleconf.conf
#cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
#cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
#ret=0
#
#incf=%{_confdir}/sampleconf.incl

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable sample daemon
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# handle include files
#if [ -e "$incf" ]; then
#	rm $incf.rpmnew
#else
#	mv $incf.rpmnew $incf
#	echo "Check $incf"
#fi

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# add a (new) template to sample
#f=/.../sample						# pathname of file
#templ=%{_datadir}/sample.add				# template in datadir
#tmpf=/tmp/sample					# tempfile
#flag=sampledir						# flag for entries
#if [ -e $f ]; then					# file exist
#	grep -q $flag $f				# look for flag
#	ret=$?
#	if [ $ret -ne 0 ]; then				# no flag found
#		cat $templ >> $f			# add entries
#	else						# flag found
#		cat $f | grep $flag > $tmpf		# get add from file
#		cmp -s $tmpf $templ			# cmp add vs. templ
#		ret=$?
#		if [ $ret -ne 0 ]; then			# templ is new
#			cat $f | grep -v $flag > $tmpf	# rm add from file
#			cp $tmpf $f
#			cat $templ >> $f		# add new entries
#		fi
#		rm -f $tmpf
#	fi
#else
#	echo "File $f not found!"
#fi

# INIT SCRIPT/SYSTEMD UNIT - install samplename
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/sampledm.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable sampledm.service
#	echo "sampledm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start sampledm within yast or manual with:"
#	echo "systemctl start sampledm.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/sampledm.rc %{_rcdir}/sampledm
#	ln -sf %{_rcdir}/sampledm %{_sbindir}/rcsampledm
#	insserv sampledm > /dev/null 2>&1
#	echo "sampledm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start sampledm within yast or manual with rcsampledm start"
#fi

# install/update all users rc files
#updcmd='' usr='' u=''
#updcmd="%{_bindir}/update-sample -q"
# for all usr below /home/ do:
#usr=$(/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1)
#for u in $usr; do
#	/bin/su $u -c "$updcmd"
#done

if [ "$1" == 1 ]; then					# install package
	mkdir -p %{_dbdir}
	chmod 755 %{_dbdir}
	if [ ! -e %{_dbdir}/ksm-registry.dat ]; then
		cp /dev/null %{_dbdir}/ksm-registry.dat
		chmod 644 %{_dbdir}/ksm-registry.dat
	fi

#	echo "Configure $cf"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		c='' s='' t=''
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		cnt=0 i=0
#		# array var MainArr (contignous index from 0)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				let ++i
#			done
#		fi
#
#		# array var MainArr (contignous index from 1)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				let ++i
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
fi
# if libraries contained:
#ldconfig
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/sampleconf.conf && cp %{_confdir}/sampleconf.conf %{_confdir}/sampleconf.conf.rpmsave
	#test -e %{_scnfdir}/sampleconf && cp %{_scnfdir}/sampleconf %{_scnfdir}/sampleconf.rpmsave

	# disable sample daemon and stop sampledm
	#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop

	# remove entries from file sample
	#f=/.../sample					# pathname of file
	#tmpf=/tmp/sample				# tempfile
	#flag=sampledir					# flag for entries
	#ret=0
	#if [ -e $f ]; then
	#	grep -q $flag $f			# look for flag
	#	ret=$?
	#	if [ $ret -eq 0 ]; then			# flag found
	#		cat $f | grep -v $flag > $tmpf	# rm add from file
	#		cp $tmpf $f
	#		rm -f $tmpf
	#	fi
	#else
	#	echo "File $f not found!"
	#fi

	# INIT SCRIPT/SYSTEMD UNIT - uninstall samplename
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/sampledm.service ]; then
	#		systemctl stop sampledm.service
	#		systemctl disable sampledm.service
	#		rm %{_sysddir}/sampledm.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#		test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1
	#		insserv -r sampledm > /dev/null 2>&1
	#		rm -f %{_rcdir}/sampledm
	#		rm -f %{_sbindir}/rcsampledm
	#	fi
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sampledir
#else							# upgrade package
fi
exit 0

%changelog
* Thu Dec 01 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.2.0
- The prog ksm-registry has been revised/improved
  (fixed false logger call).

* Sat Feb 05 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.1.0
- The prog ksm-registry has been revised/improved
  (fixed errmsg).

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.0.0
- Update to the libfuncstd-sh 4.0.0

* Wed Apr 26 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.12.0
- Some permissions have been changed.

* Mon Apr 10 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.11.0
- All progs have been revised
  (fixed init for var 'err').

* Tue Feb 07 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.10.0
- All scripts have been revised
  (using function GetOpt).

* Fri Jan 06 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.9.0
- All scripts have been revised.

* Thu Feb 18 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.8.0
- The script ksm-registry has been revised.

* Thu Feb 18 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.7.0
- The script ksm-registry has been revised
  (fixed error cmd -n while modify pkg.inf).

* Wed Feb 17 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.6.0
- The script ksm-registry has been revised
  (fixed error cmd -n if pkg-name has a path).

* Thu Oct 16 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.5.1
- The docu of the package has been revised.

* Tue Oct 09 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.5.0
- The script ksm-registry has been revised.

* Sat Sep 29 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.4.0
- The package has been revised.

* Tue Apr 03 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.3.0
- The release naming scheme has changed ('.ksm' is removed).

* Mon Mar 12 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.3.0.ksm
- The script ksm-registry is revised.

* Sat Oct 29 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.2.0.ksm
- This is an adaptation to ksm-lib-sh-1.0.5-5.0.0.ksm.
- The script ksm-registry is revised.

* Fri Oct 28 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.1.0.ksm
- This is an adaptation to ksm-lib-sh-1.0.5-4.0.0.ksm.
- The script ksm-registry is revised (removed options -b, -e).

* Thu Oct 27 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-1.0.0.ksm
- This is an adaptation to ksm-lib-sh-1.0.5-3.0.0.ksm.

* Wed Oct 26 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.9.0.ksm
- The script ksm-registry is revised (cmd -t options).

* Tue Oct 25 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.8.0.ksm
- The script ksm-registry is revised (cmd -o changed to option -o).

* Tue Oct 25 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.7.0.ksm
- The package ksm-registry is revised (copying of data from old data dir
  will not longer supported).

* Tue Oct 25 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.6.0.ksm
- The package ksm-registry is revised (the file prefix 'info' has
  changed to 'data').

* Mon Oct 24 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.5.0.ksm
- The package ksm-registry is revised (cmd -r).

* Mon Oct 24 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.4.0.ksm
- The package ksm-registry is revised (cmd -n).

* Sun Oct 23 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.3.0.ksm
- The package ksm-registry is revised.

* Sat Oct 22 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.2.0.ksm
- The package ksm-registry is revised.

* Fri Oct 21 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.0.ksm
- The script ksm-registry is revised.
- The DB dir has changed to /var/local/ksm-registry.

* Tue Jan 04 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.5.ksm
- The package name has changed from registry-ksm to ksm-registry.
- The main data file has changed from registry-ksm.dat to ksm-registry.dat

* Wed Jun 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.5.ksm
- The package is revised.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.4.ksm
- Read version and dependency infos from external files.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.3.ksm
- The docu has changed.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.2.ksm
- The package name (Release) has changed.

* Wed Nov 18 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.ksm.0.1
- The package has revised.
- Lib-SH version 1.0.2 is required.

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The package management has changed to RPM.
